diff -r 3d001eab27e3 make/Makefile
--- a/make/Makefile	Thu Dec 17 16:12:58 2015 +0300
+++ b/make/Makefile	Wed Feb 10 11:46:21 2016 -0600
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2005, 2015, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2005, 2016, Oracle and/or its affiliates. All rights reserved.
 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 #
 # This code is free software; you can redistribute it and/or modify it
@@ -109,18 +109,11 @@
 all_debug:     debug1 docs export_debug
 all_optimized: optimized1 docs export_optimized
 else
-ifeq ($(MACOSX_UNIVERSAL),true)
-all_product:   universal_product
-all_fastdebug: universal_fastdebug
-all_debug:     universal_debug
-all_optimized: universal_optimized
-else
 all_product:   $(COMMON_VM_PRODUCT_TARGETS)
 all_fastdebug: $(COMMON_VM_FASTDEBUG_TARGETS)
 all_debug:     $(COMMON_VM_DEBUG_TARGETS)
 all_optimized: $(COMMON_VM_OPTIMIZED_TARGETS)
 endif
-endif
 
 allzero:           all_productzero all_fastdebugzero
 all_productzero:   productzero docs export_product
@@ -854,11 +847,9 @@
 	@$(ECHO) \
 "  $(MAKE) ALT_JDK_IMPORT_PATH=/opt/java/jdk$(VERSION_STRING)"
 
-# Universal build support
+# Mac OS X build support
 ifeq ($(OS_VENDOR), Darwin)
-ifeq ($(MACOSX_UNIVERSAL),true)
-include $(GAMMADIR)/make/$(OSNAME)/makefiles/universal.gmk
-endif
+include $(GAMMADIR)/make/$(OSNAME)/makefiles/macosx.gmk
 endif
 
 # Compatibility for transition to new naming
diff -r 3d001eab27e3 make/bsd/makefiles/defs.make
--- a/make/bsd/makefiles/defs.make	Thu Dec 17 16:12:58 2015 +0300
+++ b/make/bsd/makefiles/defs.make	Wed Feb 10 11:46:21 2016 -0600
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2006, 2015, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2006, 2016, Oracle and/or its affiliates. All rights reserved.
 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 #
 # This code is free software; you can redistribute it and/or modify it
@@ -325,58 +325,44 @@
   endif
 endif
 
-# Universal build settings
+# Mac OS X build settings
 ifeq ($(OS_VENDOR), Darwin)
-  # Build universal binaries by default on Mac OS X
-  MACOSX_UNIVERSAL = true
-  ifneq ($(ALT_MACOSX_UNIVERSAL),)
-    MACOSX_UNIVERSAL = $(ALT_MACOSX_UNIVERSAL)
-  endif
-  MAKE_ARGS += MACOSX_UNIVERSAL=$(MACOSX_UNIVERSAL)
 
-  # Universal settings
-  ifeq ($(MACOSX_UNIVERSAL), true)
+	# Set export path but avoid using ARCH or PLATFORM subdirs
+	EXPORT_PATH=$(OUTPUTDIR)/export-macosx$(EXPORT_SUBDIR)
+	ifneq ($(ALT_EXPORT_PATH),)
+	  EXPORT_PATH=$(ALT_EXPORT_PATH)
+	endif
 
-    # Set universal export path but avoid using ARCH or PLATFORM subdirs
-    EXPORT_PATH=$(OUTPUTDIR)/export-universal$(EXPORT_SUBDIR)
-    ifneq ($(ALT_EXPORT_PATH),)
-      EXPORT_PATH=$(ALT_EXPORT_PATH)
-    endif
+	# Set image dir
+	JDK_IMAGE_DIR=$(OUTPUTDIR)/jdk-macosx$(EXPORT_SUBDIR)
+	ifneq ($(ALT_JDK_IMAGE_DIR),)
+	  JDK_IMAGE_DIR=$(ALT_JDK_IMAGE_DIR)
+	endif
 
-    # Set universal image dir
-    JDK_IMAGE_DIR=$(OUTPUTDIR)/jdk-universal$(EXPORT_SUBDIR)
-    ifneq ($(ALT_JDK_IMAGE_DIR),)
-      JDK_IMAGE_DIR=$(ALT_JDK_IMAGE_DIR)
-    endif
+	# Files to copy in place
+	MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/libjsig.$(LIBRARY_SUFFIX)
+	MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/server/libjvm.$(LIBRARY_SUFFIX)
+	MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/client/libjvm.$(LIBRARY_SUFFIX)
+	MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/server/Xusage.txt
+	MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/client/Xusage.txt
 
-    # Binaries to 'universalize' if built
-    ifneq ($(STATIC_BUILD),true)
-    UNIVERSAL_LIPO_LIST += $(EXPORT_LIB_DIR)/libjsig.$(LIBRARY_SUFFIX)
-    endif
-    UNIVERSAL_LIPO_LIST += $(EXPORT_LIB_DIR)/server/libjvm.$(LIBRARY_SUFFIX)
-    UNIVERSAL_LIPO_LIST += $(EXPORT_LIB_DIR)/client/libjvm.$(LIBRARY_SUFFIX)
+	ifeq ($(STATIC_BUILD),true)
+	  MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/server/libjvm.symbols
+	  MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/client/libjvm.symbols
+	  MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/minimal/libjvm.symbols
+	endif
 
-    # Files to simply copy in place
-    UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/server/Xusage.txt
-    UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/client/Xusage.txt
-
-    ifeq ($(STATIC_BUILD),true)
-      UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/server/libjvm.symbols
-      UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/client/libjvm.symbols
-      UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/minimal/libjvm.symbols
-    endif
-
-    ifeq ($(ENABLE_FULL_DEBUG_SYMBOLS),1)
-      ifeq ($(ZIP_DEBUGINFO_FILES),1)
-          UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/server/libjvm.diz
-          UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/client/libjvm.diz
-          UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/libjsig.diz
-      else
-          UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/server/libjvm.$(LIBRARY_SUFFIX).dSYM
-          UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/client/libjvm.$(LIBRARY_SUFFIX).dSYM
-          UNIVERSAL_COPY_LIST += $(EXPORT_LIB_DIR)/libjsig.$(LIBRARY_SUFFIX).dSYM
-      endif
-    endif
+	ifeq ($(ENABLE_FULL_DEBUG_SYMBOLS),1)
+	  ifeq ($(ZIP_DEBUGINFO_FILES),1)
+	      MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/server/libjvm.diz
+	      MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/client/libjvm.diz
+	      MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/libjsig.diz
+	  else
+	      MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/server/libjvm.$(LIBRARY_SUFFIX).dSYM
+	      MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/client/libjvm.$(LIBRARY_SUFFIX).dSYM
+	      MACOSX_COPY_LIST += $(EXPORT_LIB_DIR)/libjsig.$(LIBRARY_SUFFIX).dSYM
+	  endif
 
   endif
 endif
diff -r 3d001eab27e3 make/defs.make
--- a/make/defs.make	Thu Dec 17 16:12:58 2015 +0300
+++ b/make/defs.make	Wed Feb 10 11:46:21 2016 -0600
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2006, 2015, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2006, 2016, Oracle and/or its affiliates. All rights reserved.
 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 #
 # This code is free software; you can redistribute it and/or modify it
@@ -345,13 +345,6 @@
 EXPORT_BIN_DIR = $(EXPORT_PATH)/bin
 EXPORT_LIB_ARCH_DIR = $(EXPORT_LIB_DIR)/$(LIBARCH)
 
-# non-universal macosx builds need to appear universal
-ifeq ($(OS_VENDOR), Darwin)
-  ifneq ($(MACOSX_UNIVERSAL), true)
-    EXPORT_LIB_ARCH_DIR = $(EXPORT_LIB_DIR)
-  endif
-endif
-
 # Common export list of files
 EXPORT_LIST += $(EXPORT_INCLUDE_DIR)/jvmti.h
 EXPORT_LIST += $(EXPORT_INCLUDE_DIR)/jvmticmlr.h